title Touch Keypad for Mach3
rem (c)2012 Martin Kennedy
rem rev 0: 1-1-2012

rem see if Mach3 is running
%W = @winatpoint(46,13)
IF @NOT(@EQUAL(@SUBSTR(@wintext(%W),1,9),Mach3 CNC))
   %R = @msgbox(Mach3 is not onscreen and maximized,Error,$000)
   Exit
END

rem read configuration file
%C = @CURDIR()\ScreenSetMacros\Probe.set\TouchKeypad.INI
%F = @FILE(%C)  
IF @NULL(@FILE(%F))  
   INFO INI file %C does not exist  
   Exit
END   
INIFILE OPEN,%C

rem initialization
%G = ""	
%X = @INIREAD(setup,TKleft)
%Y = @INIREAD(setup,TKtop)

  DIALOG CREATE,TouchKeypad,%Y,%X,310,410,COLOR 804000
REM *** Modified by Dialog Designer on 1/1/2012 - 20:56 ***
  DIALOG ADD,TASKICON,TASKICON1,#TouchKeypad.ico,TouchKeypad by 10K
  DIALOG ADD,STYLE,Style1,Arial,16,B
  DIALOG ADD,STYLE,Style2,Arial,16,,FFFF80,BLACK
  DIALOG ADD,STYLE,Style3,Arial,10,B,,
  DIALOG TITLE,Mach3 TouchKeypad by 10K
  DIALOG ADD,LINE,LINE1,10,10,290,30
  DIALOG ADD,LINE,LINE2,164,64,240,240
  DIALOG ADD,TEXT,GCode,14,14,282,22,,TouchKeypad (C)2012 MKennedy All Rights Reserved,Style2
  DIALOG ADD,BUTTON,command1,50,70,170,50,@INIREAD(history,command1),Last G-Code Issued,Style3
  DIALOG ADD,BUTTON,More,50,10,50,50,History,History of G-Codes Issued,Style3
  DIALOG ADD,BUTTON,BackSpace,50,250,50,50,BkSpc,Delete Last Entry,Style3
  DIALOG ADD,BUTTON,C,110,10,50,50,C,Jog Constant Velocity Percent,Style1
  DIALOG ADD,BUTTON,F,110,70,50,50,F,Feedrate,Style1
  DIALOG ADD,BUTTON,G,110,130,50,50,G,G-Code,Style1
  DIALOG ADD,BUTTON,M,110,190,50,50,M,Control,Style1
  DIALOG ADD,BUTTON,S,110,250,50,50,S,Spindle Speed,Style1
  DIALOG ADD,BUTTON,A,170,10,50,50,A,Fourth Axis,Style1
  DIALOG ADD,BUTTON,seven,170,70,50,50,7,Seven,Style1
  DIALOG ADD,BUTTON,eight,170,130,50,50,8,Eight,Style1
  DIALOG ADD,BUTTON,nine,170,190,50,50,9,Nine,Style1
  DIALOG ADD,BUTTON,Z,230,10,50,50,Z,Z Axis,Style1
  DIALOG ADD,BUTTON,four,230,70,50,50,4,Four,Style1
  DIALOG ADD,BUTTON,five,230,130,50,50,5,Five,Style1
  DIALOG ADD,BUTTON,six,230,190,50,50,6,Six,Style1
  DIALOG ADD,BUTTON,Minus,230,250,50,50,-,Negative,Style1
  DIALOG ADD,BUTTON,Y,290,10,50,50,Y,Y Axis,Style1
  DIALOG ADD,BUTTON,One,290,70,50,50,1,One,Style1
  DIALOG ADD,BUTTON,Two,290,130,50,50,2,Two,Style1
  DIALOG ADD,BUTTON,Three,290,190,50,50,3,Three,Style1
  DIALOG ADD,BUTTON,Period,290,250,50,50,.,Decimal,Style1
  DIALOG ADD,BUTTON,X,350,10,50,50,X,X Axis,Style1
  DIALOG ADD,BUTTON,Zero,350,70,50,50,0,Zero,Style1
  DIALOG ADD,BUTTON,Space,350,130,80,50,Space,Space,Style3
  DIALOG ADD,BUTTON,Enter,350,220,80,50,Enter,Execute Code,Style3
  DIALOG SHOW

%K = @WINACTIVE()

rem process touchscreen input
:waitloop
	WAIT EVENT
	%B = @EVENT()
    IF @EQUAL(%B,CLOSE)
         Goto ExitButton
    ELSIF @EQUAL(%B,EnterBUTTON)
         IF @EQUAL(@LEN(%G),0)
            Goto ExitButton
         ELSE
            Goto ExecuteGCode
         END
    ELSIF @EQUAL(%B,OneBUTTON)
         %G = %G1
    ELSIF @EQUAL(%B,TwoBUTTON)
         %G = %G2
    ELSIF @EQUAL(%B,ThreeBUTTON)
         %G = %G3
    ELSIF @EQUAL(%B,FourBUTTON)
         %G = %G4
    ELSIF @EQUAL(%B,FiveBUTTON)
         %G = %G5
    ELSIF @EQUAL(%B,SixBUTTON)
         %G = %G6
    ELSIF @EQUAL(%B,SevenBUTTON)
         %G = %G7
    ELSIF @EQUAL(%B,EightBUTTON)
         %G = %G8
    ELSIF @EQUAL(%B,NineBUTTON)
         %G = %G9
    ELSIF @EQUAL(%B,ZeroBUTTON)
         %G = %G0
    ELSIF @EQUAL(%B,MinusBUTTON)
         %G = %G-
    ELSIF @EQUAL(%B,PeriodBUTTON)
         %G = %G.
    ELSIF @EQUAL(%B,SpaceBUTTON)
         rem use alternate character from INI so space will show up
         %G = %G@CHR(@INIREAD(setup,Space))
    ELSIF @EQUAL(%B,MBUTTON)
         %G = %GM
    ELSIF @EQUAL(%B,SBUTTON)
         %G = %GS
    ELSIF @EQUAL(%B,GBUTTON)
         %G = %GG
    ELSIF @EQUAL(%B,FBUTTON)
         %G = %GF
    ELSIF @EQUAL(%B,XBUTTON)
         %G = %GX
    ELSIF @EQUAL(%B,YBUTTON)
         %G = %GY
    ELSIF @EQUAL(%B,ZBUTTON)
         %G = %GZ
    ELSIF @EQUAL(%B,ABUTTON)
         %G = %GA
    ELSIF @EQUAL(%B,CBUTTON)
         %G = %GC
    ELSIF @EQUAL(%B,BackSpaceBUTTON)
         %G = @STRDEL(%G,@LEN(%G))
    ELSIF @EQUAL(%B,command1BUTTON)
         %G = @INIREAD(history,command1)
         Goto ExecuteGCode
    ELSIF @EQUAL(%B,MoreBUTTON)
         rem pop up second screen
         DIALOG HIDE

  DIALOG CREATE,Command History,@SUM(%Y,20),@SUM(%X,20),250,490,COLOR 804000
REM *** Modified by Dialog Designer on 1/1/2012 - 09:06 ***
  DIALOG ADD,STYLE,Style4,Arial,12,B,,
  DIALOG ADD,BUTTON,command1,10,10,230,50,@INIREAD(history,command1),Last Command,Style4
  DIALOG ADD,BUTTON,command2,70,10,230,50,@INIREAD(history,command2),Second to Last Command,Style4
  DIALOG ADD,BUTTON,command3,130,10,230,50,@INIREAD(history,command3),Third to Last Command,Style4
  DIALOG ADD,BUTTON,command4,190,10,230,50,@INIREAD(history,command4),Fourth to Last Command,Style4
  DIALOG ADD,BUTTON,command5,250,10,230,50,@INIREAD(history,command5),Fifth to Last Command,Style4
  DIALOG ADD,BUTTON,command6,310,10,230,50,@INIREAD(history,command6),Sixth to Last Command,Style4
  DIALOG ADD,BUTTON,command7,370,10,230,50,@INIREAD(history,command7),Seventh to Last Command,Style4
  DIALOG ADD,BUTTON,command8,430,10,230,50,@INIREAD(history,command8),Eighth to Last Command,Style4
  DIALOG SHOWMODAL

         WAIT EVENT
	     %B = @EVENT()
         IF @EQUAL(%B,CLOSE)
	        DIALOG CLOSE
            REM Wait for the CLOSE event that is generated...
	        WAIT EVENT
            REM ...and throw it away (otherwise it will be executed
            REM by the main event loop!)
	        WHILE @EVENT()
            WEND
            DIALOG SHOW
            Goto waitloop
         ELSIF @EQUAL(%B,command1BUTTON)
               %G = @INIREAD(history,command1)
         ELSIF @EQUAL(%B,command2BUTTON)
               %G = @INIREAD(history,command2)
         ELSIF @EQUAL(%B,command3BUTTON)
               %G = @INIREAD(history,command3)
         ELSIF @EQUAL(%B,command4BUTTON)
               %G = @INIREAD(history,command4)
         ELSIF @EQUAL(%B,command5BUTTON)
               %G = @INIREAD(history,command5)
         ELSIF @EQUAL(%B,command6BUTTON)
               %G = @INIREAD(history,command6)
         ELSIF @EQUAL(%B,command7BUTTON)
               %G = @INIREAD(history,command7)
         ELSIF @EQUAL(%B,command8BUTTON)
               %G = @INIREAD(history,command8)
         END
         DIALOG CLOSE
         Goto ExecuteGCode

    END

    DIALOG SET, GCode, %G
    GOTO waitloop

:ExecuteGCode
    rem hide dialog box and set focus to Mach3
    DIALOG HIDE
    WINDOW ACTIVATE,%W

    rem reset spaces
    %I = @LEN(%G)
    REPEAT
        IF @EQUAL(@SUBSTR(%G,%I),@CHR(@INIREAD(setup,Space)))
           %G = @STRDEL(%G,%I)
           %G = @STRINS(%G,%I,@CHR(32))
        END
        %I = @PRED(%I)
    UNTIL @GREATER(1,%I)
    
    rem clear any active windows
    WINDOW SEND,%W,@ESC()@ESC()
    IF @EQUAL(@SUBSTR(%G,1,1),X)
       rem reset X DRO handle 3998758
       WINDOW CLICK,%W,@INIREAD(DRO,XDROleft),@INIREAD(DRO,XDROtop)
       WAIT 1
       WINDOW SEND,%W,@SUBSTR(%G,2,@LEN(%G))@CR()
    ELSIF @EQUAL(@SUBSTR(%G,1,1),Y)
       rem reset Y DRO
       WINDOW CLICK,%W,@INIREAD(DRO,YDROleft),@INIREAD(DRO,YDROtop)
       WAIT 1
       WINDOW SEND,%W,@SUBSTR(%G,2,@LEN(%G))@CR()
    ELSIF @EQUAL(@SUBSTR(%G,1,1),Z)
       rem reset Z DRO
       WINDOW CLICK,%W,@INIREAD(DRO,ZDROleft),@INIREAD(DRO,ZDROtop)
       WAIT 1
       WINDOW SEND,%W,@SUBSTR(%G,2,@LEN(%G))@CR()
    ELSIF @EQUAL(@SUBSTR(%G,1,1),A)
       rem reset A DRO
       WINDOW CLICK,%W,@INIREAD(DRO,ADROleft),@INIREAD(DRO,ADROtop)
       WAIT 1
       WINDOW SEND,%W,@SUBSTR(%G,2,@LEN(%G))@CR()
    ELSIF @EQUAL(@SUBSTR(%G,1,1),C)
       rem reset Constant Jog Rate
       WINDOW CLICK,%W,@INIREAD(feedrate,Cleft),@INIREAD(feedrate,Ctop)
       WAIT 1
       WINDOW SEND,%W,@SUBSTR(%G,2,@LEN(%G))@CR()
    ELSE
       rem send a G-Code
       WINDOW CLICK,%W,@INIREAD(MDI,MDIleft),@INIREAD(MDI,MDItop)
       WAIT 1
       WINDOW SEND,%W,%G@CR()

       rem save command
       rem don't save if same as most current entry
       IF @NOT(@EQUAL(%G,@INIREAD(history,command1)))
          %I = 8
          REPEAT
             rem move previous commands in queue
             INIFILE WRITE,history,command%I,@INIREAD(history,command@PRED(%I))
             %I = @PRED(%I)
          UNTIL @GREATER(2,%I)   
          INIFILE WRITE,history,command1,%G
       END
    END
    
:ExitButton
    rem write window position
    INIFILE WRITE,setup,TKLeft,@WINPOS(%K,L)
    INIFILE WRITE,setup,TKTop,@WINPOS(%K,T)
    rem return value of string when exiting function (currently not used)
	EXIT %G
    
